<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Whatsapp rest api auth</title>
    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0-beta1/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-0evHe/X+R7YkIZDRvuzKMRqM+OrBnVFBL6DOitfPri4tjfHxaWutUpFmBp4vmVor"
      crossorigin="anonymous"
    />
  </head>
  <body>
    <nav class="navbar navbar-expand navbar-dark bg-success">
      <div class="container-sm">
        <div class="collapse navbar-collapse p-2" id="navbarNav">
          <ul class="nav navbar-nav">
            <li>
              <a href="#" class="navbar-brand">
                <img src="wa.png" height="35" />
                Whatsapp Web Rest Api
              </a>
            </li>
          </ul>
          <ul class="nav navbar-nav end-0">
            <li class="nav-item">
              <a
                class="btn btn-dark btn-sm"
                aria-current="page"
                id="api_doc"
                href="javascript:void(0)"
                >Api Docs</a
              >
            </li>
          </ul>
        </div>
      </div>
    </nav>

    <div id="app" class="container mt-5">
      <div class="row">
        <div class="col-sm-12">
          <!-- <h4>Status</h4>
                <hr> -->
          <table
            class="table table-bordered table-striped table-responsive col-sm-4"
          >
            <tr>
              <td colspan="2" align="center">
                <span class="badge text-bg-primary" id="log"
                  >Connecting ...</span
                >
              </td>
            </tr>
            <tr>
              <td>Authenticated ?</td>
              <td>
                <div id="is_auth">
                  <span class="badge text-bg-danger">No</span>
                </div>
              </td>
            </tr>
            <tr>
              <td>Rest Api Ready ?</td>
              <td>
                <div id="rest_api">
                  <span class="badge text-bg-danger">No</span>
                </div>
              </td>
            </tr>
            <tr>
              <td>User Name</td>
              <td>
                <span id="user_name">-</span>
              </td>
            </tr>
            <tr>
              <td>User Id</td>
              <td>
                <span id="user_id">-</span>
              </td>
            </tr>
            <tr>
              <td>Phone Number</td>
              <td>
                <span id="phone_number">-</span>
              </td>
            </tr>
            <tr>
              <td colspan="2" align="center">
                <a
                  href="#"
                  class="badge text-bg-danger text-decoration-none"
                  id="logout"
                  style="display: none"
                  >Logout</a
                >
                <div id="auth" style="display: none">
                  <h3>Scan QR Code to login</h3>
                  <image id="qrcode" />
                </div>
              </td>
            </tr>
          </table>
        </div>
      </div>
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0-beta1/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-pprn3073KE6tl6bjs2QrFaJGz5/SUsLqktiwsUTF55Jfv3qYSDhgCecCxMW52nD2"
      crossorigin="anonymous"
    ></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.5.1/socket.io.js"></script>
    <script>
      $(document).ready(function () {
        $("#api_doc").click(function () {
          var url = window.location.href + "api-docs";
          url = url.replace("#", "");
          window.open(url, "_blank");
        });

        var socket = io();
        
        socket.on("init", function (msg) {
          $("#is_auth").html(`<span class="badge text-bg-danger">No</span>`);
          $("#user_id").html('-');
          $("#user_name").html('-');
          $("#phone_number").html('-');
          $("#rest_api").html(
            `<span class="badge text-bg-danger">No</span>`
          );
        });

        socket.on("log", function (msg) {
          $("#log").html(msg);
        });

        socket.on("qr", function (qr) {
          $("#qrcode").attr("src", qr);
          $("#logout").hide();
          $("#auth").show();
        });

        socket.on("userInfo", function (userInfo) {
          if (userInfo) {
            $("#user_id").html(userInfo.me._serialized);
            $("#user_name").html(userInfo.pushname);
            $("#phone_number").html(userInfo.me.user);
            $("#rest_api").html(
              `<span class="badge text-bg-success">Yes</span>`
            );
          }
        });

        socket.on("authenticated", function () {
          $("#is_auth").html(`<span class="badge text-bg-success">Yes</span>`);
          // $("#logout").show();
          $("#auth").hide();
        });

        socket.on("ready", function () {
          $("#rest_api").html(`<span class="badge text-bg-success">Yes</span>`);
        });

        $("#logout").click(function () {
          const logout = confirm("Are you sure want to logout ?");

          if (logout) {
            socket.emit("logout", "logout");
            $("#logout").hide();
          }
        });
      });
    </script>
  </body>
</html>
